PROGRAM Kohonen;

CONST
      pi = 3.14159;

TYPE
      vektor = RECORD x,y : real END;

VAR                                                     { global }
  netz                       : ARRAY [1..15,1..15] OF vektor;
  a,b                        : integer;                 { Ellipsenhalbachsen }
  r                          : integer;                 { Kreisradius }
  alpha_0,alpha_lmax,r0      : real;                    { Anpassungsparameter }
  l_max, l_aktuell           : integer;                 { Lernschritte }
  s                          : vektor;                  { Stimulus }
  ie,je                      : 1..15;                   { Erregungszentrum }


PROCEDURE initialisierung;
VAR i,j : 1..15;

BEGIN
 { Eingabe der Parameter a, b, r, alpha_0, alpha_lmax, r0 und lMax }
      FOR i:=1 TO 15 DO
         FOR j:=1 TO 15 DO
            WITH netz [i, j] DO { whle die Werte x und y zufllig }
END;


FUNCTION alpha (a0,an : real) : real;
BEGIN
      alpha := a0 * exp ((l_aktuell-1) / (l_max-1) * ln (an/a0))
END; { alpha }


FUNCTION beta (ni,nj : integer) : real;
 { ni und nj sind die Gitterpositionen des benachbarten Neurons n }
VAR exponent : real;
BEGIN
      exponent := -(sqr(ni-ie)+sqr(nj-je)) /(2 * sqr(alpha(r0,1)));
      IF exponent < - 6 THEN beta:=0
      ELSE beta := exp (exponent)
END; { beta }


FUNCTION gamma : integer;
BEGIN
      gamma := 1;
      IF sqr (s.x) + sqr (s.y)< sqr (r) THEN gamma := 3
END; { gamma }


PROCEDURE erregungszentrum_bestimmen;
VAR i, j            : 0..15;
    min, abstand    : real;

BEGIN
      ie := 1; je := 1;
      min := sqr (netz [1,1].x-s.x) + sqr (netz [1,1].y-s.y);
      FOR i:=1 TO 15 DO
         FOR j:=1 TO 15 DO
            BEGIN
              abstand := sqr (netz [i,j].x-s.x) + sqr (netz [i,j].y-s.y);
              IF abstand < min THEN
                 BEGIN
                   ie:=i; je:=j; min:=abstand
                 END; { IF }
            END; { FOR }
END; { erregerzentrum_bestimmen }


PROCEDURE adaption;
 {eventuell hier alpha, beta, gamma lokal definieren }
VAR ni, nj         : 0..15;
    faktor         : real;

BEGIN
      FOR ni:=1 TO 15 DO
         FOR nj:=1 TO 15 DO
            BEGIN
              faktor := alpha (alpha_0,alpha_lmax) * beta (ni,nj) * gamma;
              WITH netz [ni,nj] DO
                BEGIN
                  x := x + faktor * (s.x - x);
                  y := y + faktor * (s.y - y);
                END; { WITH }
            END; { FOR }
END; { adaption }

PROCEDURE ausgabe;
BEGIN
 { Ausgabeprozedur ist je nach verwendetetem Compiler selbst zu programmieren}
END;

BEGIN { Hauptprogramm }
      initialisierung;
      FOR l_aktuell := 1 TO l_max DO
         BEGIN
          { whle Stimulus }
            erregungszentrum_bestimmen;
            adaption;
            ausgabe;
         END
END.

